# Übungen Software-Entwicklung 3: Build Management & Testing

## Ausgangslage
Die in der Vorlesung vorgestellten Konzepte des Build Managements und des Testings sollen nun in Ihrem Projekt angewandt werden. Sofern Sie Java einsetzen, verwenden Sie `Maven` für das Build Management und `JUnit` für das Testing. 

## Aufgabe
* Erstellen Sie eine passende `pom.xml`, sodass sie die Build-Lifecycle Phasen `compile`, `test` und `package` nutzen können.
* Überlegen Sie sich welche Testarten für Sie relevant sein könnten.
* Erstellen Sie Unit-Tests nach dem `F.I.R.S.T`-Prinzip. Achten Sie auch darauf, dass Sie den "Happy Path", Randbedingungen sowie Fehlerfälle testen.
* Erstellen Sie Integrationstests für Ihre Komponenten.

## Tipps
* `IntelliJ` kann Sie bei der Testerstellung unterstützen. Dafür müssen Sie in einer `.java`-Datei `command` + `n`/`Strg` + `n` ➡️ `Test...` wählen.
* Nutzen Sie bei Bedarf (z.B. Simulation eines komplexen Objekts) das Mock-Framework [Mockito](https://site.mockito.org)
* Versuchen Sie eine Funktionalität/Anforderung nach den Test-driven Design Prinzipen zu entwickeln.


## Ziele
* Das Projekt besitzt eine valide Maven-Konfiguration, mit der per `mvn`-Aufruf das Projekt automatisch getestet und gebaut wird.
* Ihre `Model` und `Controller`-Klassen werden wie oben beschrieben getestet.
* Zusätzlich werden die Schnittstellen Ihre Komponenten nach diesen Regeln getestet.